Index: c/src/exec/libnetworking/ChangeLog
===================================================================
--- c/src/exec/libnetworking/ChangeLog	(revision 40323b5b3739f36cc96cffcc30111e95cde2d3b2)
+++ c/src/exec/libnetworking/ChangeLog	(revision 407bc8c9eef987ccaea352d4ca69cf8bfdeed044)
@@ -1,2 +1,6 @@
+2000-12-14	Eric Norum <eric.norum@usask.ca>
+
+	* lib/tftpDriver.c: Added write capability.
+
 2000-12-08	Joel Sherrill <joel@OARcorp.com>
 
Index: c/src/exec/libnetworking/lib/tftpDriver.c
===================================================================
--- c/src/exec/libnetworking/lib/tftpDriver.c	(revision 40323b5b3739f36cc96cffcc30111e95cde2d3b2)
+++ c/src/exec/libnetworking/lib/tftpDriver.c	(revision 407bc8c9eef987ccaea352d4ca69cf8bfdeed044)
@@ -1,3 +1,5 @@
 /*
+ * vim: set expandtab tabstop=4 shiftwidth=4 ai :
+ * 
  * Trivial File Transfer Protocol (RFC 1350)
  *
@@ -11,4 +13,5 @@
  *
  *  $Id$
+ *
  */
 
@@ -37,31 +40,31 @@
  * Range of UDP ports to try
  */
-#define UDP_PORT_BASE	3180
+#define UDP_PORT_BASE        3180
 
 /*
  * Pathname prefix
  */
-#define TFTP_PATHNAME_PREFIX	"/TFTP/"
+#define TFTP_PATHNAME_PREFIX "/TFTP/"
 
 /*
  * Default limits
  */
-#define PACKET_REPLY_MILLISECONDS	6000
-#define OPEN_RETRY_LIMIT	10
-#define IO_RETRY_LIMIT		10
+#define PACKET_REPLY_MILLISECONDS     6000
+#define OPEN_RETRY_LIMIT              10
+#define IO_RETRY_LIMIT                10
 
 /*
  * TFTP opcodes
  */
-#define TFTP_OPCODE_RRQ		1
-#define TFTP_OPCODE_WRQ		2
-#define TFTP_OPCODE_DATA	3
-#define TFTP_OPCODE_ACK		4
-#define TFTP_OPCODE_ERROR	5
+#define TFTP_OPCODE_RRQ     1
+#define TFTP_OPCODE_WRQ     2
+#define TFTP_OPCODE_DATA    3
+#define TFTP_OPCODE_ACK     4
+#define TFTP_OPCODE_ERROR   5
 
 /*
  * Largest data transfer
  */
-#define TFTP_BUFSIZE	512
+#define TFTP_BUFSIZE        512
 
 /*
@@ -69,37 +72,37 @@
  */
 union tftpPacket {
-	/*
-	 * RRQ/WRQ packet
-	 */
-	struct tftpRWRQ {
-		rtems_unsigned16	opcode;
-		char			filename_mode[TFTP_BUFSIZE];
-	} tftpRWRQ;
-
-	/*
-	 * DATA packet
-	 */
-	struct tftpDATA {
-		rtems_unsigned16	opcode;
-		rtems_unsigned16	blocknum;
-		rtems_unsigned8		data[TFTP_BUFSIZE];
-	} tftpDATA;
-
-	/*
-	 * ACK packet
-	 */
-	struct tftpACK {
-		rtems_unsigned16	opcode;
-		rtems_unsigned16	blocknum;
-	} tftpACK;
-
-	/*
-	 * ERROR packet
-	 */
-	struct tftpERROR {
-		rtems_unsigned16	opcode;
-		rtems_unsigned16	errorCode;
-		char			errorMessage[TFTP_BUFSIZE];
-	} tftpERROR;
+    /*
+     * RRQ/WRQ packet
+     */
+    struct tftpRWRQ {
+        rtems_unsigned16    opcode;
+        char                filename_mode[TFTP_BUFSIZE];
+    } tftpRWRQ;
+
+    /*
+     * DATA packet
+     */
+    struct tftpDATA {
+        rtems_unsigned16    opcode;
+        rtems_unsigned16    blocknum;
+        rtems_unsigned8     data[TFTP_BUFSIZE];
+    } tftpDATA;
+
+    /*
+     * ACK packet
+     */
+    struct tftpACK {
+        rtems_unsigned16    opcode;
+        rtems_unsigned16    blocknum;
+    } tftpACK;
+
+    /*
+     * ERROR packet
+     */
+    struct tftpERROR {
+        rtems_unsigned16    opcode;
+        rtems_unsigned16    errorCode;
+        char                errorMessage[TFTP_BUFSIZE];
+    } tftpERROR;
 };
 
@@ -108,32 +111,33 @@
  */
 struct tftpStream {
-	/*
-	 * Buffer for storing most recently-received packet
-	 */
-	union tftpPacket	pkbuf;
-
-	/*
-	 * Last block number received
-	 */
-	rtems_unsigned16	blocknum;
-
-	/*
-	 * Data transfer socket
-	 */
-	int			socket;
-	struct sockaddr_in	myAddress;
-	struct sockaddr_in	farAddress;
-
-	/*
-	 * Indices into buffer
-	 */
-	int	nleft;
-	int	nused;
-
-	/*
-	 * Flags
-	 */
-	int	firstReply;
-	int	eof;
+    /*
+     * Buffer for storing most recently-received packet
+     */
+    union tftpPacket    pkbuf;
+
+    /*
+     * Last block number transferred
+     */
+    rtems_unsigned16    blocknum;
+
+    /*
+     * Data transfer socket
+     */
+    int                 socket;
+    struct sockaddr_in  myAddress;
+    struct sockaddr_in  farAddress;
+
+    /*
+     * Indices into buffer
+     */
+    int     nleft;
+    int     nused;
+
+    /*
+     * Flags
+     */
+    int     firstReply;
+    int     eof;
+    int     writing;
 };
 
@@ -169,5 +173,5 @@
 };
 
-int rtems_tftp_mount_me(
+static int rtems_tftp_mount_me(
   rtems_filesystem_mount_table_entry_t *temp_mt_entry
 )
@@ -225,50 +229,48 @@
 int rtems_bsdnet_initialize_tftp_filesystem () 
 {
- int                                   status;
- rtems_filesystem_mount_table_entry_t *entry;
-
- status = mkdir( TFTP_PATHNAME_PREFIX, S_IRWXU | S_IRWXG | S_IRWXO );
- if ( status == -1 )
-   return status; 
-
-  status = mount( 
-     &entry,
-     &rtems_tftp_ops,
-     RTEMS_FILESYSTEM_READ_ONLY,
-     NULL,
-     TFTP_PATHNAME_PREFIX
-  );
-
-  if ( status )
-    perror( "TFTP mount failed" );
-
-  return status;
-}
-
-/*
- * Set error message
- * This RTEMS/UNIX error mapping needs to be fixed!
- */
-static void
-tftpSetErrno (struct tftpStream *tp)
-{
-	unsigned int tftpError;
-	static const int errorMap[] = {
-		0,
-		ENOENT,
-		EPERM,
-		ENOSPC,
-		EINVAL,
-		ENXIO,
-		EEXIST,
-		ESRCH,
-		0,
-	};
-
-	tftpError = ntohs (tp->pkbuf.tftpERROR.errorCode);
-	if (tftpError < (sizeof errorMap / sizeof errorMap[0]))
-		errno = errorMap[tftpError];
-	else
-		errno = 1000 + tftpError;
+    int                                   status;
+    rtems_filesystem_mount_table_entry_t *entry;
+
+    status = mkdir( TFTP_PATHNAME_PREFIX, S_IRWXU | S_IRWXG | S_IRWXO );
+    if ( status == -1 )
+        return status; 
+
+    status = mount( 
+            &entry,
+            &rtems_tftp_ops,
+            RTEMS_FILESYSTEM_READ_WRITE,
+            NULL,
+            TFTP_PATHNAME_PREFIX
+    );
+
+    if ( status )
+        perror( "TFTP mount failed" );
+
+    return status;
+}
+
+/*
+ * Map error message
+ */
+static int
+tftpErrno (struct tftpStream *tp)
+{
+    unsigned int tftpError;
+    static const int errorMap[] = {
+        EINVAL,
+        ENOENT,
+        EPERM,
+        ENOSPC,
+        EINVAL,
+        ENXIO,
+        EEXIST,
+        ESRCH,
+    };
+
+    tftpError = ntohs (tp->pkbuf.tftpERROR.errorCode);
+    if (tftpError < (sizeof errorMap / sizeof errorMap[0]))
+        return errorMap[tftpError];
+    else
+        return 1000 + tftpError;
 }
 
@@ -279,20 +281,23 @@
 sendStifle (struct tftpStream *tp, struct sockaddr_in *to)
 {
-	int len;
-
-	/*
-	 * Create the error packet (Unknown transfer ID).
-	 */
-	tp->pkbuf.tftpERROR.opcode = htons (TFTP_OPCODE_ERROR);
-	tp->pkbuf.tftpERROR.errorCode = htons (5);
-	len = sizeof tp->pkbuf.tftpERROR.opcode +
-				sizeof tp->pkbuf.tftpERROR.errorCode + 1;
-	len += sprintf (tp->pkbuf.tftpERROR.errorMessage, "GO AWAY"); 
-
-	/*
-	 * Send it
-	 */
-	sendto (tp->socket, (char *)&tp->pkbuf, len, 0,
-					(struct sockaddr *)to, sizeof *to);
+    int len;
+    struct {
+        rtems_unsigned16    opcode;
+        rtems_unsigned16    errorCode;
+        char                errorMessage[12];
+    } msg;
+
+    /*
+     * Create the error packet (Unknown transfer ID).
+     */
+    msg.opcode = htons (TFTP_OPCODE_ERROR);
+    msg.errorCode = htons (5);
+    len = sizeof msg.opcode + sizeof msg.errorCode + 1;
+    len += sprintf (msg.errorMessage, "GO AWAY"); 
+
+    /*
+     * Send it
+     */
+    sendto (tp->socket, (char *)&msg, len, 0, (struct sockaddr *)to, sizeof *to);
 }
 
@@ -303,40 +308,40 @@
 getPacket (struct tftpStream *tp)
 {
-	int len;
-	struct timeval tv;
-
-	tv.tv_sec = PACKET_REPLY_MILLISECONDS / 1000;
-	tv.tv_usec = (PACKET_REPLY_MILLISECONDS % 1000) * 1000;
-	setsockopt (tp->socket, SOL_SOCKET, SO_RCVTIMEO, &tv, sizeof tv);
-	for (;;) {
-		union {
-			struct sockaddr s;
-			struct sockaddr_in i;
-		} from;
-		int fromlen = sizeof from;
-		len = recvfrom (tp->socket, (char *)&tp->pkbuf,
-							sizeof tp->pkbuf, 0,
-							&from.s, &fromlen);
-		if (len < 0)
-			break;
-		if (from.i.sin_addr.s_addr == tp->farAddress.sin_addr.s_addr) {
-			if (tp->firstReply) {
-				tp->firstReply = 0;
-				tp->farAddress.sin_port = from.i.sin_port;
-			}
-			if (tp->farAddress.sin_port == from.i.sin_port) 
-				break;
-		}
-
-		/*
-		 * Packet is from someone with whom we are
-		 * not interested.  Tell them to go away.
-		 */
-		sendStifle (tp, &from.i);
-	}
-	tv.tv_sec = 0;
-	tv.tv_usec = 0;
-	setsockopt (tp->socket, SOL_SOCKET, SO_RCVTIMEO, &tv, sizeof tv);
-	return len;
+    int len;
+    struct timeval tv;
+
+    tv.tv_sec = PACKET_REPLY_MILLISECONDS / 1000;
+    tv.tv_usec = (PACKET_REPLY_MILLISECONDS % 1000) * 1000;
+    setsockopt (tp->socket, SOL_SOCKET, SO_RCVTIMEO, &tv, sizeof tv);
+    for (;;) {
+        union {
+            struct sockaddr s;
+            struct sockaddr_in i;
+        } from;
+        int fromlen = sizeof from;
+        len = recvfrom (tp->socket, (char *)&tp->pkbuf,
+                                                    sizeof tp->pkbuf, 0,
+                                                    &from.s, &fromlen);
+        if (len < 0)
+            break;
+        if (from.i.sin_addr.s_addr == tp->farAddress.sin_addr.s_addr) {
+            if (tp->firstReply) {
+                tp->firstReply = 0;
+                tp->farAddress.sin_port = from.i.sin_port;
+            }
+            if (tp->farAddress.sin_port == from.i.sin_port) 
+                break;
+        }
+
+        /*
+         * Packet is from someone with whom we are
+         * not interested.  Tell them to go away.
+         */
+        sendStifle (tp, &from.i);
+    }
+    tv.tv_sec = 0;
+    tv.tv_usec = 0;
+    setsockopt (tp->socket, SOL_SOCKET, SO_RCVTIMEO, &tv, sizeof tv);
+    return len;
 }
 
@@ -347,18 +352,18 @@
 sendAck (struct tftpStream *tp)
 {
-	/*
-	 * Create the acknowledgement
-	 */
-	tp->pkbuf.tftpACK.opcode = htons (TFTP_OPCODE_ACK);
-	tp->pkbuf.tftpACK.blocknum = htons (tp->blocknum);
-
-	/*
-	 * Send it
-	 */
-	if (sendto (tp->socket, (char *)&tp->pkbuf, sizeof tp->pkbuf.tftpACK, 0,
-					(struct sockaddr *)&tp->farAddress,
-					sizeof tp->farAddress) < 0)
-		return errno;
-	return 0;
+    /*
+     * Create the acknowledgement
+     */
+    tp->pkbuf.tftpACK.opcode = htons (TFTP_OPCODE_ACK);
+    tp->pkbuf.tftpACK.blocknum = htons (tp->blocknum);
+
+    /*
+     * Send it
+     */
+    if (sendto (tp->socket, (char *)&tp->pkbuf, sizeof tp->pkbuf.tftpACK, 0,
+                                    (struct sockaddr *)&tp->farAddress,
+                                    sizeof tp->farAddress) < 0)
+        return errno;
+    return 0;
 }
 
@@ -369,11 +374,11 @@
 releaseStream (int s)
 {
-	rtems_semaphore_obtain (tftp_mutex, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
-	free (tftpStreams[s]);
-	tftpStreams[s] = NULL;
-	rtems_semaphore_release (tftp_mutex);
-}
-
-int rtems_tftp_evaluate_for_make(
+    rtems_semaphore_obtain (tftp_mutex, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
+    free (tftpStreams[s]);
+    tftpStreams[s] = NULL;
+    rtems_semaphore_release (tftp_mutex);
+}
+
+static int rtems_tftp_evaluate_for_make(
    const char                         *path,       /* IN     */
    rtems_filesystem_location_info_t   *pathloc,    /* IN/OUT */
@@ -384,9 +389,6 @@
 }
 
-/*
- * XXX - Fix return values.
- */
-
-int rtems_tftp_eval_path(  
+
+static int rtems_tftp_eval_path(  
   const char                        *pathname,     /* IN     */
   int                                flags,        /* IN     */
